#!/usr/bin/perl
use strict;
use warnings;
#use integer;
my $version="6b";
#----------------------------------------
#Variables
#----------------------------------------
my $correct_ImageMagick_version = "6.3.0";
#Do you want debugging reports turned on? If this is a mystery to you then you don't want it on.
my $DEBUG=0;
my $num_of_arg;
my $x; my $y=0;
my @array;
my $black; my $white;
my $input_file; 
#This is the default white value. It is about grey29 or grey30 on a 256 greyscale.
my $which_white=72;
my @spreadsheet_array;
my $column; my $row;
my $max_column=0; my $max_row=0;
my $header="";
#$cell_number is the current cell that we are working with.
my $cell_number;

#@ARGV is an array that contains all of the command-line arguments.
#If it is empty, the test will fail, a suggestion will print and the program will exit.
#Use !=0 if you want just one argument. Use <1 is you want no fewer than 2 arguments.
#Use < 0 if you want 1 or more arguments.  Zero arguments gives a $#ARGV = -1.
# <3 means at least 4 arguments.
#This is how we handle wildcards. We let Bash handle the expansion of filenames.
#We just read them from $ARGV[];
if($#ARGV <1)
{
	print "\n\n\n\n";
	print "|----------------------------------April 4, 2007-------------------------------------|\n";
	print " version#$version\n";
	print " I expect version $correct_ImageMagick_version of the ImageMagick tools\n\n";
	print " tested on SUSE verion 10\n\n";
	print "	Use me like this: $0 [white_value_to_use] [image_names(s)]\n";
	print " 128 is usually the best value. 72 is the minimal that we ever use.\n";
	print " This is the lowest value of white that you want me to record.\n";
	print " Bigger numbers are more white, smaller numbers are more black\n";
	print " I will count the amount of white between white_value_to_use and pure white.\n\n";
	print " I expect that the image will be a 256 grey scale image\n";
	print " I will return the amount of white.\n\n";
	print " I will store the data in a file called results.txt.\n";
	print " Be careful because I will overwrite any pre-exisiting file with this name\n";
	print " $0 [white_value_to_use] [image_name(s)]\n";
	print " I acccept wild cards, but not Visa or Mastercard.\n";
	print "|--------------------------------by Nigel Atkinson-----------------------------------|\n";
	exit; 
}
else
{
	print "version#$version\n";
}


my $version_checker=`identify -version`;
#Data looks like this:
#Version: ImageMagick 6.3.0
if($version_checker=~/Version: ImageMagick (\S+)/)
	{
		if($correct_ImageMagick_version ne $1)
		{
			print "This script expects ImageMagick version $correct_ImageMagick_version.\n";
			print "You are using version $1\n";
			print "Contact Nigel Atkinson to get an updated script.\n";
			exit;
		}
	}
else
	{
		print "I cannot determine the ImageMagick version.\n";
		print "I expect that the command \"identify -version\" will return the version number\n";
		print "Contact Nigel Atkinson to get an updated script.\n";
		exit;
	}	

#----------------------------------------------------
#open the outputfile which will store the spreadsheet
#This will be a tab delimited text file.
my $output_file;
$output_file="results.txt";
unless(open(OUTPUTFILE,">$output_file"))
{
	print("\ncannot open $output_file\n");
	exit;
}
#----------------------------------------------------
$num_of_arg = @ARGV;

#----------------------------------------------------
#Load the Dec to Hex conversion hash

my %dec_to_hex_hash= (
"000000"   =>	"0",
"010101"   =>	"1",
"020202"   =>	"2",
"030303"   =>	"3",
"040404"   =>	"4",
"050505"   =>	"5",
"060606"   =>	"6",
"070707"   =>	"7",
"080808"   =>	"8",
"090909"   =>	"9",
"0A0A0A"   =>	"10",
"0B0B0B"   =>	"11",
"0C0C0C"   =>	"12",
"0D0D0D"   =>	"13",
"0E0E0E"   =>	"14",
"0F0F0F"   =>	"15",
"101010"   =>	"16",
"111111"   =>	"17",
"121212"   =>	"18",
"131313"   =>	"19",
"141414"   =>	"20",
"151515"   =>	"21",
"161616"   =>	"22",
"171717"   =>	"23",
"181818"   =>	"24",
"191919"   =>	"25",
"1A1A1A"   =>	"26",
"1B1B1B"   =>	"27",
"1C1C1C"   =>	"28",
"1D1D1D"   =>	"29",
"1E1E1E"   =>	"30",
"1F1F1F"   =>	"31",
"202020"   =>	"32",
"212121"   =>	"33",
"222222"   =>	"34",
"232323"   =>	"35",
"242424"   =>	"36",
"252525"   =>	"37",
"262626"   =>	"38",
"272727"   =>	"39",
"282828"   =>	"40",
"292929"   =>	"41",
"2A2A2A"   =>	"42",
"2B2B2B"   =>	"43",
"2C2C2C"   =>	"44",
"2D2D2D"   =>	"45",
"2E2E2E"   =>	"46",
"2F2F2F"   =>	"47",
"303030"   =>	"48",
"313131"   =>	"49",
"323232"   =>	"50",
"333333"   =>	"51",
"343434"   =>	"52",
"353535"   =>	"53",
"363636"   =>	"54",
"373737"   =>	"55",
"383838"   =>	"56",
"393939"   =>	"57",
"3A3A3A"   =>	"58",
"3B3B3B"   =>	"59",
"3C3C3C"   =>	"60",
"3D3D3D"   =>	"61",
"3E3E3E"   =>	"62",
"3F3F3F"   =>	"63",
"404040"   =>	"64",
"414141"   =>	"65",
"424242"   =>	"66",
"434343"   =>	"67",
"444444"   =>	"68",
"454545"   =>	"69",
"464646"   =>	"70",
"474747"   =>	"71",
"484848"   =>	"72",
"494949"   =>	"73",
"4A4A4A"   =>	"74",
"4B4B4B"   =>	"75",
"4C4C4C"   =>	"76",
"4D4D4D"   =>	"77",
"4E4E4E"   =>	"78",
"4F4F4F"   =>	"79",
"505050"   =>	"80",
"515151"   =>	"81",
"525252"   =>	"82",
"535353"   =>	"83",
"545454"   =>	"84",
"555555"   =>	"85",
"565656"   =>	"86",
"575757"   =>	"87",
"585858"   =>	"88",
"595959"   =>	"89",
"5A5A5A"   =>	"90",
"5B5B5B"   =>	"91",
"5C5C5C"   =>	"92",
"5D5D5D"   =>	"93",
"5E5E5E"   =>	"94",
"5F5F5F"   =>	"95",
"606060"   =>	"96",
"616161"   =>	"97",
"626262"   =>	"98",
"636363"   =>	"99",
"646464"	=>	"100",
"656565"	=>	"101",
"666666"	=>	"102",
"676767"	=>	"103",
"686868"	=>	"104",
"696969"	=>	"105",
"6A6A6A"	=>	"106",
"6B6B6B"	=>	"107",
"6C6C6C"	=>	"108",
"6D6D6D"	=>	"109",
"6E6E6E"	=>	"110",
"6F6F6F"	=>	"111",
"707070"	=>	"112",
"717171"	=>	"113",
"727272"	=>	"114",
"737373"	=>	"115",
"747474"	=>	"116",
"757575"	=>	"117",
"767676"	=>	"118",
"777777"	=>	"119",
"787878"	=>	"120",
"797979"	=>	"121",
"7A7A7A"	=>	"122",
"7B7B7B"	=>	"123",
"7C7C7C"	=>	"124",
"7D7D7D"	=>	"125",
"7E7E7E"	=>	"126",
"7F7F7F"	=>	"127",
"808080"	=>	"128",
"818181"	=>	"129",
"828282"	=>	"130",
"838383"	=>	"131",
"848484"	=>	"132",
"858585"	=>	"133",
"868686"	=>	"134",
"878787"	=>	"135",
"888888"	=>	"136",
"898989"	=>	"137",
"8A8A8A"	=>	"138",
"8B8B8B"	=>	"139",
"8C8C8C"	=>	"140",
"8D8D8D"	=>	"141",
"8E8E8E"	=>	"142",
"8F8F8F"	=>	"143",
"909090"	=>	"144",
"919191"	=>	"145",
"929292"	=>	"146",
"939393"	=>	"147",
"949494"	=>	"148",
"959595"	=>	"149",
"969696"	=>	"150",
"979797"	=>	"151",
"989898"	=>	"152",
"999999"	=>	"153",
"9A9A9A"	=>	"154",
"9B9B9B"	=>	"155",
"9C9C9C"	=>	"156",
"9D9D9D"	=>	"157",
"9E9E9E"	=>	"158",
"9F9F9F"	=>	"159",
"A0A0A0"	=>	"160",
"A1A1A1"	=>	"161",
"A2A2A2"	=>	"162",
"A3A3A3"	=>	"163",
"A4A4A4"	=>	"164",
"A5A5A5"	=>	"165",
"A6A6A6"	=>	"166",
"A7A7A7"	=>	"167",
"A8A8A8"	=>	"168",
"A9A9A9"	=>	"169",
"AAAAAA"	=>	"170",
"ABABAB"	=>	"171",
"ACACAC"	=>	"172",
"ADADAD"	=>	"173",
"AEAEAE"	=>	"174",
"AFAFAF"	=>	"175",
"B0B0B0"	=>	"176",
"B1B1B1"	=>	"177",
"B2B2B2"	=>	"178",
"B3B3B3"	=>	"179",
"B4B4B4"	=>	"180",
"B5B5B5"	=>	"181",
"B6B6B6"	=>	"182",
"B7B7B7"	=>	"183",
"B8B8B8"	=>	"184",
"B9B9B9"	=>	"185",
"BABABA"	=>	"186",
"BBBBBB"	=>	"187",
"BCBCBC"	=>	"188",
"BDBDBD"	=>	"189",
"BEBEBE"	=>	"190",
"BFBFBF"	=>	"191",
"C0C0C0"	=>	"192",
"C1C1C1"	=>	"193",
"C2C2C2"	=>	"194",
"C3C3C3"	=>	"195",
"C4C4C4"	=>	"196",
"C5C5C5"	=>	"197",
"C6C6C6"	=>	"198",
"C7C7C7"	=>	"199",
"C8C8C8"	=>	"200",
"C9C9C9"	=>	"201",
"CACACA"	=>	"202",
"CBCBCB"	=>	"203",
"CCCCCC"	=>	"204",
"CDCDCD"	=>	"205",
"CECECE"	=>	"206",
"CFCFCF"	=>	"207",
"D0D0D0"	=>	"208",
"D1D1D1"	=>	"209",
"D2D2D2"	=>	"210",
"D3D3D3"	=>	"211",
"D4D4D4"	=>	"212",
"D5D5D5"	=>	"213",
"D6D6D6"	=>	"214",
"D7D7D7"	=>	"215",
"D8D8D8"	=>	"216",
"D9D9D9"	=>	"217",
"DADADA"	=>	"218",
"DBDBDB"	=>	"219",
"DCDCDC"	=>	"220",
"DDDDDD"	=>	"221",
"DEDEDE"	=>	"222",
"DFDFDF"	=>	"223",
"E0E0E0"	=>	"224",
"E1E1E1"	=>	"225",
"E2E2E2"	=>	"226",
"E3E3E3"	=>	"227",
"E4E4E4"	=>	"228",
"E5E5E5"	=>	"229",
"E6E6E6"	=>	"230",
"E7E7E7"	=>	"231",
"E8E8E8"	=>	"232",
"E9E9E9"	=>	"233",
"EAEAEA"	=>	"234",
"EBEBEB"	=>	"235",
"ECECEC"	=>	"236",
"EDEDED"	=>	"237",
"EEEEEE"	=>	"238",
"EFEFEF"	=>	"239",
"F0F0F0"	=>	"240",
"F1F1F1"	=>	"241",
"F2F2F2"	=>	"242",
"F3F3F3"	=>	"243",
"F4F4F4"	=>	"244",
"F5F5F5"	=>	"245",
"F6F6F6"	=>	"246",
"F7F7F7"	=>	"247",
"F8F8F8"	=>	"248",
"F9F9F9"	=>	"249",
"FAFAFA"	=>	"250",
"FBFBFB"	=>	"251",
"FCFCFC"	=>	"252",
"FDFDFD"	=>	"253",
"FEFEFE"	=>	"254",
"FFFFFF"	=>	"255");


#----------------------------------------------------
#If we have provided a grey value then use it, if not then use the default.
if($ARGV[0]>0)
{
	$which_white=$ARGV[0];
}

$column="";
#File names begin with the second entry on the command line.
for($x=1;$x<$num_of_arg;$x++)
{
	$input_file=$ARGV[$x];
	#Decided to skip the monochroming. Greyscale gives less noise.
	#print `convert -monochrome $input_file $output_file`;

	#Data looks like this: cell_001.00002.jpg
	print "input_file=$input_file\n";
	if($input_file=~/cell_(\d+).(\d+).jpg/)
	{
		$column=$1;
		$row=$2;

		#Here we are just bullet proofing things.
                if ($column > $max_column)
                {
                        $max_column=$column;
                }
                if ($row > $max_row)
                {
                        $max_row=$row;
                }

	}	
	
	@array=`identify -verbose $input_file`;
	$white=0; $black=0;

	for($y=0; $y<@array; $y++)
	{
  		#  Histogram:
    		#    247541: (  0,  0,  0)	black
      		#      2459: (240,240,240)	grey94
         	#	5: ( 87, 87, 87)	grey34
		#This will harvest the black number.
		#if($array[$y]=~/\w+(\d+):\s\(\s*\d+,\s*\d+,\s*\d+\)\s*black$/)
		#{
			#$black=$1;
		#}
		#Let's use grey29 as a default. I think that grey 29 is ( 72, 72, 72).
		#In the statement below we really don't need to capture $2, $3 & $4. However, we might be able to use it
		#as a way to confirm that all of the values are the same. If this is grey scale then all should be
		#the same value.
		# New
		# Histogram:
		#         17: black                                         #000000
		#          5: rgb(1,1,1)                                    #010101
		#          9: rgb(2,2,2)                                    #020202
		#         13: grey1                                         #030303
		#         17: rgb(4,4,4)                                    #040404
		#         14: grey2                                         #050505
		#                          
		# Colormap: 256 <------- Make it end when it hits this
		#                                                    
		if($array[$y]=~/\s*(\d+): \S*\s*#(\S*)/)
		{ 
			#Now collect all of the greys that we want to call white.
			#First guess was 72
			if($dec_to_hex_hash{$2}>=$which_white)
			{
				$white=$white+$1;
			}
		}
		if($array[$y+1]=~/\s*Colormap/)
		{
			#last;
			$y=@array;
		}
	}
	#$cell_number is how we want each column in the spreadsheet to begin.
	#It would be nice to store this in an 2 dim array.
	#spreadsheet_array[column][row] where the columns are different cells and the row are differnt times.

	$spreadsheet_array[$column][$row]= "$white";
	$spreadsheet_array[$column][0]="cell_$column";

	#print "$spreadsheet_array[$column][$row]\n";
	#print "$spreadsheet_array[$column][0]\n";
	#print "$input_file\t$white\n";
}

my $print_row; my $print_col;
print "-------------------------------------------------------------------\n";
print "Total number of rows=$max_row, of columns=$max_column\n";
for $print_row(0 .. $max_row)
{
	for $print_col(0 .. $max_column)
	{
		print $spreadsheet_array[$print_col][$print_row]."\t";
		print OUTPUTFILE $spreadsheet_array[$print_col][$print_row]."\t";
	}
	print "\n";
	print OUTPUTFILE "\n";
}
exit;

